﻿using Hotline.Share.Dtos.Knowledge;
using XF.Domain.Repository;

namespace Hotline.KnowledgeBase
{
    public interface IKnowledgeService
    {
        /// <summary>
        /// 根据用户ID获取当前用户所属部门及下级部门Id
        /// </summary>
        /// <param name="userId"></param>
        /// <returns></returns>
        Task<List<string>> GetChildBMId(string? userId);

        /// <summary>
        /// 知识库-知识修改-查询详情
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        Task<Knowledge> KnowledgeUpdateInfo(string Id, CancellationToken cancellationToken);

        /// <summary>
        /// 知识库-查询详情-增加浏览量
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        Task<Knowledge> KnowledgeInfo(string Id, CancellationToken cancellationToken);

        /// <summary>
        /// 知识库-新增
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task<string> KnowledgeAdd(AddKnowledgeDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 知识库-修改
        /// </summary>
        /// <param name="dto"></param>
        /// <returns></returns>
        Task KnowledgeUpdate(UpdateKnowledgeDto dto, CancellationToken cancellationToken);

        /// <summary>
        /// 审批操作
        /// </summary>
        /// <param name="Ids">需要审批的数据ID</param>
        /// <param name="ApprovalStatus">审核状态：0：通过；1：不通过</param>
        /// <param name="HandleOpinions">办理意见</param>
        /// <returns></returns>
        Task ApprovalHandle(List<string> Ids, string ApprovalStatus, string HandleOpinions, CancellationToken cancellationToken);
    }
}
